Package: groovy.mock.interceptor

## [Java] Class MockProxyMetaClass

- groovy.mock.interceptor.MockProxyMetaClass

-     public class MockProxyMetaClass
      extends ProxyMetaClass

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `boolean` | `interceptConstruction` |

  - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class ProxyMetaClass` | `adaptee, interceptor`
    `class MetaClassImpl` | `EMPTY_ARGUMENTS, INVOKE_METHOD_METHOD, METHOD_MISSING, PROPERTY_MISSING, STATIC_METHOD_MISSING, STATIC_PROPERTY_MISSING, getPropertyMethod, invokeMethodMethod, isGroovyObject, isMap, metaMethodIndex, registry, setPropertyMethod, theCachedClass, theClass`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `MockProxyMetaClass(MetaClassRegistry registry, Class theClass, MetaClass adaptee)` Parameters: `adaptee` - the MetaClass to decorate with interceptability
    `MockProxyMetaClass(MetaClassRegistry registry, Class theClass, MetaClass adaptee, boolean interceptConstruction)` Parameters: `adaptee` - the MetaClass to decorate with interceptability

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public Object` | `getProperty(Class aClass, Object object, String property, boolean b, boolean b1)`
    `` | `public Object` | `invokeConstructor(Object[] arguments)` Unlike general impl in superclass, ctors are not intercepted but relayed unless interceptConstruction is set.
    `` | `public Object` | `invokeMethod(Object object, String methodName, Object[] arguments)`
    `` | `public Object` | `invokeMethod(Class sender, Object object, String methodName, Object[] arguments, boolean isCallToSuper, boolean fromInsideClass)`
    `` | `public Object` | `invokeStaticMethod(Object object, String methodName, Object[] arguments)`
    `` | `public static MockProxyMetaClass` | `make(Class theClass)` convenience factory method for the most usual case.
    `` | `public static MockProxyMetaClass` | `make(Class theClass, boolean interceptConstruction)` convenience factory method allowing interceptConstruction to be set.
    `` | `public void` | `setProperty(Class aClass, Object object, String property, Object newValue, boolean b, boolean b1)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class ProxyMetaClass` | `getAdaptee, getInstance, getInterceptor, getProperty, initialize, invokeConstructor, invokeMethod, invokeMethod, invokeStaticMethod, setAdaptee, setInterceptor, setProperty, use, use`
    `class MetaClassImpl` | `getMetaMethod, getMetaProperty, getRegistry, getStaticMetaMethod, getSuperClasses, getTheCachedClass, getTheClass, hasProperty, isGroovyObject, methodNameAction, respondsTo, respondsTo, skipClass`

- - ### Field Detail

    - #### public final boolean interceptConstruction

  - ### Constructor Detail

    - #### public MockProxyMetaClass(MetaClassRegistry registry, Class theClass, MetaClass adaptee)

      Parameters:
        `adaptee` - the MetaClass to decorate with interceptability

    - #### public MockProxyMetaClass(MetaClassRegistry registry, Class theClass, MetaClass adaptee, boolean interceptConstruction)

      Parameters:
        `adaptee` - the MetaClass to decorate with interceptability

  - ### Method Detail

    - #### @Override public Object getProperty(Class aClass, Object object, String property, boolean b, boolean b1)

    - #### @Override public Object invokeConstructor(Object[] arguments)

      Unlike general impl in superclass, ctors are not intercepted but relayed unless interceptConstruction is set.

    - #### @Override public Object invokeMethod(Object object, String methodName, Object[] arguments)

    - #### @Override public Object invokeMethod(Class sender, Object object, String methodName, Object[] arguments, boolean isCallToSuper, boolean fromInsideClass)

    - #### @Override public Object invokeStaticMethod(Object object, String methodName, Object[] arguments)

    - #### public static MockProxyMetaClass make(Class theClass)

      convenience factory method for the most usual case.

    - #### public static MockProxyMetaClass make(Class theClass, boolean interceptConstruction)

      convenience factory method allowing interceptConstruction to be set.

    - #### @Override public void setProperty(Class aClass, Object object, String property, Object newValue, boolean b, boolean b1)